unit keyboard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls, StdCtrls, Buttons;

{
  Panelfarbe=$80E0FF;
  PanelGedruecktfarbe=$e0ffff;

  Panelfarbe=$FFa0a0;
  PanelGedruecktfarbe=$ffdfdf;
}
type
  TFormKeyboard = class(TForm)
    LabelTitle: TLabel;
    Label1: TLabel;

    procedure PanelMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure PanelMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);

  private
    innereHoehe:Integer;
    Farbindex:char;
    FarbtabelleGedrueckt:array['A'..'Z'] of Tcolor;
    FarbtabelleNormal:array['A'..'Z'] of Tcolor;
    procedure SetTitle(const Value: string);
    function GetTitle: string;
    procedure colorNormal(panel:Tpanel);
    procedure colorPressed(panel:Tpanel);
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure buildLayout(layout:string);
    property Title:string read GetTitle write SetTitle;
    procedure setColors(index:char; Normal, gedrueckt:Tcolor);
  end;


var
  FormKeyboard: TFormKeyboard;

implementation
uses kryptool;

{$R *.DFM}

{ TForm1 }

procedure TFormKeyboard.buildLayout(layout: string);
(*   '|00'   Zeilentrenner, gefolgt von 2 Zeichen Einrcktiefe in 1/10 Tastenbreite
     '& '    Leertaste
     '&&'    Das & Zeichen
     '&_'    Leerraum
     '&1'.. '&9'    1/10..9/10 Leerraum
     '&A'.. '&Z'    Tasten-Farbschema

*)
const
  ystart=92;       //Erste Tastenreihe
  breite=54;       //Einer Taste
  hoehe=breite;
  abstand=3;       //Zwischen den Tasten
var
  i,x,y,xa,maxx:  integer;
  panel:          Tpanel;
begin
  maxx:=0;
  x:=0;
  xa:=0;
  y:=0;
  i:=1;
  panel:=nil;

  while i<= length(layout)
  do begin
    if layout[i]='|'  //Zeilentrenner, gefolgt von 2 Zeichen Einrcktiefe (in 1/10 Tastenbreite)
    then begin
      xa:=(ord(layout[i+1])-48)*breite   + ((ord(layout[i+2])-48)*breite+9) div 10;
      x:=0;
      inc(y);
      i:=i+3;
    end else begin
      if layout[i]='&' then begin //Sonderfunktion
        Inc(i);

        if layout[i]='_'
        then begin //Sonderbehandlung: Leerraum
          inc(x);
          Inc(i);
          Continue;
        end else
        if (layout[i]>'0') and (layout[i]<='9')
        then begin //Sonderbehandlung: X-Abstand (in 1/10 Tastenbreite)
          inc(xa,(ord(layout[i])-48)*breite div 10);
          Inc(i);
          Continue;
        end else
        if (layout[i]>='A') and (layout[i]<='Z')
        then begin //Sonderbehandlung: Farbtabelle
          Farbindex:=layout[i];
          Inc(i);
          Continue;
        end else
        if layout[i]=' '
        then begin
          panel:=Tpanel.create(self);
          panel.parent:=self;
          panel.visible:=false;
          panel.OnMouseDown:=PanelMouseDown;
          panel.OnMouseUp:=PanelMouseUp;
          panel.caption:=layout[i];
          panel.Tag:=ord(Farbindex);
          colorNormal(panel);
          panel.width:=breite*4;
          panel.left:=xa+x*(breite+abstand)+abstand;
          inc(x,4);
        end else
        if layout[i]='&' //Das & Zeichen selbst
        then begin
          panel:=Tpanel.create(self);
          panel.parent:=self;
          panel.visible:=false;
          panel.OnMouseDown:=PanelMouseDown;
          panel.OnMouseUp:=PanelMouseUp;
          panel.caption:='&&'; //Sonderbehandlung & (Wird sonst zu unterstrichenem Zeichen)
          panel.caption:=layout[i];
          panel.Tag:=ord(Farbindex);
          colorNormal(panel);
          panel.width:=breite;
          panel.left:=xa+x*(breite+abstand)+abstand;
          inc(x);
        end else begin //Unbekanntes Steuerzeichen ignorieren
          inc(i);
          Continue;
        end;

      end else begin //Normales Zeichen
        panel:=Tpanel.create(self);
        panel.parent:=self;
        panel.visible:=false;
        panel.OnMouseDown:=PanelMouseDown;
        panel.OnMouseUp:=PanelMouseUp;
        panel.caption:=layout[i];
        panel.caption:=layout[i];
        panel.Tag:=ord(Farbindex);
        colorNormal(panel);
        panel.width:=breite;
        panel.left:=xa+x*(breite+abstand)+abstand;
        inc(x);
      end;
      panel.font.size:=18;
      panel.height:=hoehe;
      panel.top:=ystart+y*(hoehe+abstand);
      inc(i);
      if panel.left+panel.width>maxx then maxx:=panel.left+panel.width;
      panel.visible:=true;
    end;

  end;

  innereHoehe:=(hoehe+Abstand)*(y+1) + ystart;  //Form height
  height:=innereHoehe+32;  //Form height  +32 fr Fenstertitelzeile
  width:=maxx+30;  //Form width
  labelTitle.width:=width;
end;

procedure TFormKeyboard.PanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  colorPressed(sender as Tpanel);
  (sender as Tpanel).bevelOuter:=bvLowered;
  FormMain.myPasswd.addChar((sender as Tpanel).caption[1]);
  label1.Caption:=label1.Caption + chr(65+random(26));
  if 0=(length(label1.Caption) mod 4) then label1.Caption:=label1.Caption +' ';
end;

procedure TFormKeyboard.FormShow(Sender: TObject);
begin
  Label1.Caption:=' ';
  FormMain.myPasswd.clear;
  if BorderStyle=bsNone
  then height:=innereHoehe
  else height:=innereHoehe+32;
end;

procedure TFormKeyboard.SetTitle(const Value: string);
begin
  LabelTitle.caption := Value;
end;

function TFormKeyboard.GetTitle: string;
begin
  result:=LabelTitle.caption;
end;

procedure TFormKeyboard.PanelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  colorNormal(sender as Tpanel);
  (sender as Tpanel).bevelOuter:=bvRaised;
end;


procedure TFormKeyboard.BitBtn1Click(Sender: TObject);
begin
  close;
end;


procedure TFormKeyboard.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if #13=key then begin
    close;
  end else begin
    FormMain.myPasswd.addChar(Key);
    label1.Caption:=label1.Caption + chr(65+random(26));
    if 0=(length(label1.Caption) mod 4) then label1.Caption:=label1.Caption +' ';
  end;
end;

procedure TFormKeyboard.setColors(index: char; Normal, gedrueckt: Tcolor);
begin
  FarbtabelleGedrueckt[index]:=gedrueckt;
  FarbtabelleNormal[index]:=normal;
end;

procedure TFormKeyboard.FormCreate(Sender: TObject);
var
  c: char;
begin
  //Farbtabelle initialisieren
  setColors('A', $80E0FF, $e0ffff);
  setColors('B', $FFa0a0, $ffd0d0);
  setColors('C', $a0a0ff, $d0d0ff);
  setColors('D', $ffa0ff, $ffd0ff);
  for c:='E' to 'Z' do begin
    setColors(c, $a0a0a0, $ffffff);
  end;
  Farbindex:='A';
end;


procedure TFormKeyboard.colorNormal(panel: Tpanel);
begin
  panel.color:=FarbtabelleNormal[chr(panel.Tag)];
end;

procedure TFormKeyboard.colorPressed(panel: Tpanel);
begin
  panel.color:=FarbtabelleGedrueckt[chr(panel.Tag)];
end;

end.
